<?php
/**
 * @package	SEOProtection
 * @copyright	Copyright (C) 2017 SiteGuarding.com. All rights reserved.
 * @license	GNU General Public License version 2 or later
 */
defined('_JEXEC') or die('Restricted access');

class SEO_SG_Protection
{
    public static $search_words = array(
        0 => 'document.write(',
    	6 => 'document.createElement(',
    	20 => 'display:none',
    	21 => 'poker',
    	22 => 'casino',
    	48=> 'hacked',
    	49=> 'cialis ',
    	52=> 'viagra '
    );
    
    
    public static function PrepareResults($results)
    {
        $a = array(
            'WORDS' => array(),
            'A' => array(),
            'IFRAME' => array(),
            'SCRIPT' => array()
        );
        
        //return $results;
        
        if (count($results['posts']['WORDS']))
        {
            foreach ($results['posts']['WORDS'] as $post_id => $post_arr)
            {
                foreach ($post_arr as $word)
                {
                    $a['WORDS'][$word] = $word;
                }
            }
        }
        
        if (count($results['posts']['A']))
        {
            foreach ($results['posts']['A'] as $posts)
            {
                if (count($posts))
                {
                    foreach ($posts as $post_id => $post_arr)
                    {
                        if (count($post_arr))
                        {
                            foreach ($post_arr as $post_link => $post_txt)
                            {
                                $a['A'][$post_link] = $post_txt;
                            }
                        }
                    }
                }
            }
        }
        
        
        if (count($results['posts']['IFRAME']))
        {
            foreach ($results['posts']['IFRAME'] as $posts)
            {
                if (count($posts))
                {
                    foreach ($posts as $post_id => $post_link)
                    {
                        $a['IFRAME'][$post_link] = $post_link;
                    }
                }
            }
        }
        
        //print_r($results['posts']['IFRAME']);exit;
        if (count($results['posts']['SCRIPT']))
        {
            foreach ($results['posts']['SCRIPT'] as $post_id => $post_arr)
            {
                foreach ($post_arr as $js_link => $js_code)
                {
                    if (strpos($js_link, "javascript code") !== false) $a['SCRIPT'][md5($js_code)] = $js_code;
                    else $a['SCRIPT'][md5($js_link)] = $js_link;
                }
            }
        }
        
        //echo '0000'.$post_link;exit;
        //print_r($a); exit;
        
        ksort($a['A']);
        ksort($a['SCRIPT']);
        sort($a['IFRAME']);
        return $a;
        
    }


    public static function GetPostTitle_by_ID($post_id)
    {
        $db = JFactory::getDBO();
        $query = "SELECT id, title
            FROM #__content
            WHERE id = '".$post_id."' LIMIT 1;";
    	$db->setQuery($query);
    	$rows = $db->loadObjectList();
		if ($db->getErrorNum())
		{
			JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
			return false;
		} 
        
        if (count($rows)) return $rows[0]->title;
		else return false;
    }
    
    public static function GetPostTitles_by_IDs($post_ids = array())
    {
        $db = JFactory::getDBO();
        $query = "SELECT id, title
            FROM #__content
            WHERE id IN (".implode(",", $post_ids).")";
    	$db->setQuery($query);
    	$rows = $db->loadObjectList();
		if ($db->getErrorNum())
		{
			JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
			return false;
		}
		
        if (count($rows)) 
        {
            $a = array();
            foreach ($rows as $row)
            {
                $a[$row->id] = $row->title;
            }
            return $a;
        }
        else return false;
    }
    
    public static function MakeAnalyze()
    {
        //error_reporting(0);
        ignore_user_abort(true);
        set_time_limit(0);
        ini_set('memory_limit', '512M');
		
        $data = array(
            'progress_status' => 1,
            'latest_scan_date' => date("Y-m-d H:i:s")
        );
        self::Set_Params($data);
        
        $db = JFactory::getDBO();
        $query = "SELECT * FROM #__content";
    	$db->setQuery($query);
    	$rows = $db->loadObjectList();
		if ($db->getErrorNum())
		{
			JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
			return false;
		}

        
        $a = array();
        if (count($rows))
        {
            $domain = self::PrepareDomain(JUri::base());
            
            $a['total_scanned'] = count($rows);
            
            foreach ($rows as $row)
            {
				$post_content = "<html><body>".$row->introtext.$row->fulltext."</body></html>";
                
                foreach (self::$search_words as $find_block)
                {
                    if (stripos($post_content, $find_block) !== false)
                    {
                        $a['posts']['WORDS'][$row->id][] = $find_block;
                    }
                }
                
                $html = str_get_html($post_content);
                
                if ($html !== false)
                {
                    $tmp_a = array();
                    
                    // Tag A
                    foreach($html->find('a') as $e) 
                    {
                        $link = strtolower(trim($e->href));
                        if (strpos($link, $domain) !== false) continue;     // Skip own links
                        if (strpos($link, "mailto:") !== false) continue;
                        if (strpos($link, "callto:") !== false) continue;
                        if ( $link[0] == '?' || $link[0] == '/' ) continue;
                        if ( $link[0] != 'h' && $link[1] != 't' && $link[2] != 't' && $link[3] != 'p' ) continue;
                        
                        //$tmp_s = $link.' <span class="color_light_grey">[Txt: '.strip_tags($e->outertext).']</span>';

                        /*$tmp_data = array(
                            'l' => $link,
                            't' => strip_tags($e->outertext)
                        );
                        $tmp_a[$link] = $tmp_data;*/
                        $tmp_a[$link] = strip_tags($e->outertext);
                        
                        $a['posts']['A'][$row->id][] = $tmp_a;
                    }
                    
                    
                    
                    // Tag IFRAME
                    foreach($html->find('iframe') as $e) 
                    {
                        $link = strtolower(trim($e->src));
                        if (strpos($link, $domain) !== false) continue;     // Skip own links
                        if ( $link[0] == '?' || $link[0] == '/' ) continue;
                        if ( $link[0] != 'h' && $link[1] != 't' && $link[2] != 't' && $link[3] != 'p' ) continue;
                        
                        /*$tmp_data = array(
                            'l' => $link,
                            't' => 'iframe'
                        );
                        $tmp_a[$link] = $tmp_data;*/
                        
                        $a['posts']['IFRAME'][$row->id][] = $link;
                    }
                    
                    
                    
                	// Tag SCRIPT
                	foreach($html->find('script') as $e)
                	{
                	    if (isset($e->src)) 
                        {
                            $link = strtolower(trim($e->src));
                        
                            if (strpos($link, $domain) !== false) continue;     // Skip own links
                            if ( $link[0] == '?' || $link[0] == '/' ) continue;
                            if ( $link[0] != 'h' && $link[1] != 't' && $link[2] != 't' && $link[3] != 'p' ) continue;
                            
                            $t = '';
                        }
                        else  {
                            $link = 'javascript code '.rand(1, 1000);
                            $t = $e->innertext;
                        }
                        
                        /*$tmp_data = array(
                            'l' => $link,
                            't' => $t
                        );*/
                        $tmp_a[$link] = $t;
                        
                        $a['posts']['SCRIPT'][$row->id] = $tmp_a;
                    }
                    
                }
                
                unset($html);
            }
            
        }
        
        // save results
        $data = array(
            'progress_status' => 2,
            'results' => json_encode($a),
            'latest_scan_date' => date("Y-m-d H:i:s")
        );
        self::Set_Params($data);
    }
    
    
    
    public static function Get_Params($vars = array())
    {
        if (count($vars) == 0)
        {
			$db = JFactory::getDBO();
			$query = "SELECT *
				FROM #__seoprotection
				WHERE var_name = '".addslashes($vars)."' LIMIT 1;";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			if ($db->getErrorNum())
			{
				JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
				return false;
			} 
        }
        else {
            foreach ($vars as $k => $v) $vars[$k] = "'".$v."'";
            
			$db = JFactory::getDBO();
			$query = "SELECT *
				FROM #__seoprotection
				WHERE var_name IN (".implode(',',$vars).")";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			if ($db->getErrorNum())
			{
				JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
				return false;
			} 
        }
        
        $a = array();
        if (count($rows))
        {
            foreach ( $rows as $row ) 
            {
            	$a[trim($row->var_name)] = trim($row->var_value);
            }
        }
    
        return $a;
    }
    
    
    public static function Set_Params($data = array())
    {
        if (count($data) == 0) return;   
        
        foreach ($data as $k => $v)
        {
			$db = JFactory::getDBO();
			$query = "SELECT id FROM #__seoprotection WHERE var_name = '".addslashes($k)."'";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			if ($db->getErrorNum())
			{
				JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
				return false;
			} 
            
            if (count($rows) == 0)
            {
				$sql_array = array(
					'var_name' => $k,
					'var_value' => $v
				);
				
				// INSERT
				$db =  JFactory::getDBO();
				$query = "INSERT INTO `#__seoprotection` (".self::SQL_Params_Array($sql_array, 'keys').") VALUES ( ".self::SQL_Params_Array($sql_array, 'values')." );";
				$db->setQuery( $query );
				$db->query();
				if ($db->getErrorNum())
				{
					JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
					return false;
				}
            }
            else {
				$sql_array = array(
					'var_name' => $k,
					'var_value' => $v
				);
				
				// UPDATE
				$db =  JFactory::getDBO();
				$query = "UPDATE `#__seoprotection` SET ".self::SQL_Params_Array_Update($sql_array)." WHERE id='".intval($rows[0]->id)."' LIMIT 1;";
				$db->setQuery( $query );
				$db->query();
				if ($db->getErrorNum())
				{
					JFactory::getApplication()->enqueueMessage( $db->stderr(), 100 );
					return false;
				} 
            }
        } 
    }


	public static function PrepareDomain($domain)
	{
	    $host_info = parse_url($domain);
	    if ($host_info == NULL) return false;
	    $domain = $host_info['host'];
	    if ($domain[0] == "w" && $domain[1] == "w" && $domain[2] == "w" && $domain[3] == ".") $domain = str_replace("www.", "", $domain);
	    //$domain = str_replace("www.", "", $domain);
	    
	    return $domain;
	}

    
    public static function CheckAntivirusInstallation()
    {
        $avp_path = dirname(__FILE__);
		$avp_path = str_replace('com_seoprotection', 'com_jantivirus', $avp_path);
        return file_exists($avp_path);
    }

	
	public static function SQL_Params_Array($array, $type)
	{
		$a = '';

		switch ($type) {

			case 'keys':
				$separator = '';
				foreach ($array as $key => $value) {
			    	$a .= $separator.'`'.$key.'`';
			    	$separator = ',';
				}
				break;


			case 'values':
				$separator = '';
				foreach ($array as $key => $value) {
			    	$a .= $separator."'".addslashes($value)."'";
			    	$separator = ',';
				}
				break;
		}

		return $a;
	}
	
	public static function SQL_Params_Array_Update($array)
	{
		$a = '';
		$separator = '';
		foreach ($array as $key => $value) {
	    	$a .= $separator."`".$key."` = '".addslashes($value)."'";
	    	$separator = ',';
		}

		return $a;
	}
    

}

class SEO_SG_Protection_HTML
{
    public static function PrintIconMessage($data)
    {
        $rand_id = "id_".rand(1,10000).'_'.rand(1,10000);
        if ($data['type'] == '' || $data['type'] == 'alert') {$type_message = 'negative'; $icon = 'warning sign';}
        if ($data['type'] == 'ok') {$type_message = 'green'; $icon = 'checkmark box';}
        if ($data['type'] == 'info') {$type_message = 'yellow'; $icon = 'info';}
        ?>
        <div class="ui icon <?php echo $type_message; ?> message">
            <i class="<?php echo $icon; ?> icon"></i>
            <div class="msg_block_row">
                <?php
                if ($data['button_text'] != '' || $data['help_text'] != '') {
                ?>
                <div class="msg_block_txt">
                    <?php
                    if ($data['header'] != '') {
                    ?>
                    <div class="header"><?php echo $data['header']; ?></div>
                    <?php
                    }
                    ?>
                    <?php
                    if ($data['message'] != '') {
                    ?>
                    <p><?php echo $data['message']; ?></p>
                    <?php
                    }
                    ?>
                </div>
                <div class="msg_block_btn">
                    <?php
                    if ($data['help_text'] != '') {
                    ?>
                    <a class="link_info" href="javascript:;" onclick="InfoBlock('<?php echo $rand_id; ?>');"><i class="help circle icon"></i></a>
                    <?php
                    }
                    ?>
                    <?php
                    if ($data['button_text'] != '') {
                        if (!isset($data['button_url_target']) || $data['button_url_target'] == true) $new_window = 'target="_blank"';
                        else $new_window = '';
                    ?>
                    <a class="mini ui green button" <?php echo $new_window; ?> href="<?php echo $data['button_url']; ?>"><?php echo $data['button_text']; ?></a>
                    <?php
                    }
                    ?>
                </div>
                    <?php
                    if ($data['help_text'] != '') {
                    ?>
                        <div style="clear: both;"></div>
                        <div id="<?php echo $rand_id; ?>" style="display: none;">
                            <div class="ui divider"></div>
                            <p><?php echo $data['help_text']; ?></p>
                        </div>
                    <?php
                    }
                    ?>
                <?php
                } else {
                ?>
                    <?php
                    if ($data['header'] != '') {
                    ?>
                    <div class="header"><?php echo $data['header']; ?></div>
                    <?php
                    }
                    ?>
                    <?php
                    if ($data['message'] != '') {
                    ?>
                    <p><?php echo $data['message']; ?></p>
                    <?php
                    }
                    ?>
                <?php
                }
                ?>
            </div> 
        </div>
        <?php
    }

}

?>