<?php
/**
 * @package	SEOProtection
 * @copyright	Copyright (C) 2017 SiteGuarding.com. All rights reserved.
 * @license	GNU General Public License version 2 or later
 */
defined('_JEXEC') or die;
 

abstract class SEOProtectionHelper
{

	public static function addSubmenu($submenu) 
	{
		JSubMenuHelper::addEntry(JText::_('SEO Scanner'), 'index.php?option=com_seoprotection', $submenu == 'scanner');
		JSubMenuHelper::addEntry(JText::_('Support'), 'index.php?option=com_seoprotection&view=support', $submenu == 'support');
		// set some global property
		$document = JFactory::getDocument();
		if ($submenu == 'scanner') 
		{
			$document->setTitle(JText::_('SEO Scanner'));
		}
		if ($submenu == 'support') 
		{
			$document->setTitle(JText::_('Support'));
		}
	}
	/**
	 * Get the actions
	 */
	public static function getActions($messageId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;
 
		if (empty($messageId)) {
			$assetName = 'com_seoprotection';
		}
		else {
			$assetName = 'com_seoprotection.message.'.(int) $messageId;
		}
 
		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.delete'
		);
 
		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}
 
		return $result;
	}
}
