<?php
/**
 * @package	SEOProtection
 * @copyright	Copyright (C) 2017 SiteGuarding.com. All rights reserved.
 * @license	GNU General Public License version 2 or later
 */
defined('_JEXEC') or die('Restricted Access');

JHtml::_('behavior.tooltip');

$jinput = JFactory::getApplication()->input;

?>
    <h2 class="ui title_product"><i class="crosshairs icon"></i> SEO Scanner</h2>
    
    <div class="ui max-box">

    <div class="ui bottom attached segment">
    <?php

        $message_data = array(
            'type' => 'info',
            'header' => '',
            'message' => 'This free tool scans your posts and detects all links, iframes, JavaScripts and hidden text and codes on your pages. If you feel that website is infected, please try our Antivirus scanner or get analyze and cleaning services.',
            'button_text' => 'Clean Website',
            'button_url' => 'https://www.siteguarding.com/en/services/malware-removal-service',
            'help_text' => ''
        );
        echo '<div class="PrintIconMessage">';
        SEO_SG_Protection_HTML::PrintIconMessage($message_data);
        echo '</div>';
        

		$start_scanner = $jinput->get( 'start_scanner', 0 );
		$params = SEO_SG_Protection::Get_Params(array('progress_status', 'results', 'latest_scan_date'));
		
		if ( intval($params['progress_status']) == 1 && $params['latest_scan_date'] < date("Y-m-d H:i:s", mktime(date("H"), date("i")-10, 0, date("m") , date("d"), date("Y"))) )
		{
			$data = array(
				'progress_status' => 0
			);
			SEO_SG_Protection::Set_Params($data);
		}
		
		if ( intval($params['progress_status']) == 2) 
		{
			$start_scanner = 0;
			
			$data = array(
				'progress_status' => 0
			);
			SEO_SG_Protection::Set_Params($data);
		}

        if (intval($start_scanner) == 0)
        {
            ?>
            <form method="post" action="index.php">
				<p class="txtcenter">To start the scan process click "Start Scanner" button.</p>
				
            	<p class="submit startscanner">
            	  <input type="submit" name="submit" id="submit" class="button button-primary" value="Start Scanner">
            	</p>
				
				<p class="msg_alert"><b>Please note:</b> Some other security extensions can block the scanning process. Disable them or <a href="https://www.siteguarding.com/en/contacts" target="_blank">contact SiteGuarding.com support</a> for more information.</p>
				<p><b>Found suspicious file on your website?</b> Analyze it for free with our online tool antivirus. <a target="_blank" href="https://www.siteguarding.com/en/website-antivirus">Click here</a></p>

    		<input type="hidden" name="start_scanner" value="1"/>
			<input type="hidden" name="option" value="com_seoprotection"/>
    		</form>
            
            <?php
        }
        else {
            ?>
            <script type="text/javascript">
            window.setTimeout(function(){ document.location.reload(true); }, 10000);
            </script>
            <p style="text-align: center; width: 100%;">
                <img width="120" height="120" src="<?php echo str_replace('/administrator/', '/', JUri::base()).'media/com_seoprotection/images/ajax_loader.svg'; ?>" />
                <br /><br />
                The scanner is in progress.<br>
                Please wait, it will take 30-60 seconds.
            </p>
            <iframe src="index.php?option=com_seoprotection&start_scanner=2" style="border:0px solid #fff;height:1px;width:1px;"></iframe>
            <?php
        }
        
		?>
		</div></div>
		
		<?php
		

        if (intval($start_scanner) == 0)
        {
			?>
				<p>&nbsp;</p>
				
				<h2 class="ui title_product"><i class="desktop icon"></i> Results</h2>
				
				<div class="ui max-box">
				
				<div class="ui bottom attached segment"> 
			
			<?php
            if (isset($params['latest_scan_date']))
            {
                // Show report
                echo '<p>Latest scan was '.$params['latest_scan_date'].'</p>';
                
                $params['results'] = (array)json_decode($params['results'], true);

    
                    if (!SEO_SG_Protection::CheckAntivirusInstallation()) 
                    {
                        $message_data = array(
                            'type' => 'alert',
                            'header' => '',
                            'message' => 'Antivirus is not installed. We advice to scan all the files and folders of your website. If your website got hacked - don\'t wait until it gets blacklisted. You can loose your customers and search engine positions.',
                            'button_text' => 'Install',
                            'button_url' => 'https://extensions.joomla.org/extension/antivirus-website-protection/',
                            'help_text' => ''
                        );
                        echo '<div class="PrintIconMessage">';
                        SEO_SG_Protection_HTML::PrintIconMessage($message_data);
                        echo '</div>';
                    }

                
                if (intval($jinput->get('showdetailed')) == 0)
                {
                    /**
                     * Show simple
                     */
                    $results = SEO_SG_Protection::PrepareResults($params['results']);

                    echo '<h3>Bad words (<a href="index.php?option=com_seoprotection&showdetailed=1">show details</a>)</h3>';
                    if (count($results['WORDS']))
                    {
                        echo '<table class="ui selectable celled table small">';
                        echo '<thead><tr><th>Words</th></thead>';
                        foreach ($results['WORDS'] as $word)
                        {
                            echo '<tr>';
                            echo '<td>'.$word.'</td>';
                            echo '</tr>';
                        }
                        echo '</table>';
                    }
                    else echo '<p>No bad words detected.</p>';
                    
                    echo "<hr>";
                    
                    echo '<h3>Detected links (<a href="index.php?option=com_seoprotection&showdetailed=1">show details</a>)</h3>';
                    if (count($results['A']))
                    {
                        echo '<table class="ui selectable celled table small">';
                        echo '<thead><tr><th>Links</th><th>Text in links</th></tr></thead>';
                        foreach ($results['A'] as $link => $txt)
                        {
                            echo '<tr>';
                            echo '<td>'.$link.'</td><td>'.$txt.'</td>';
                            echo '</tr>';
                        }
                        echo '</table>';
                    }
                    else echo '<p>No strange links detected.</p>';
                    
                    echo "<hr>";
                    
                    echo '<h3>Detected iframes (<a href="index.php?option=com_seoprotection&showdetailed=1">show details</a>)</h3>';
                    if (count($results['IFRAME']))
                    {
                        echo '<table class="ui selectable celled table small">';
                        echo '<thead><tr><th>Links</th></thead>';
                        foreach ($results['IFRAME'] as $link)
                        {
                            echo '<tr>';
                            echo '<td>'.$link.'</td>';
                            echo '</tr>';
                        }
                        echo '</table>';
                    }
                    else echo '<p>No iframes detected.</p>';
                    
                    echo "<hr>";
                    
                    echo '<h3>Detected JavaScripts (<a href="index.php?option=com_seoprotection&showdetailed=1">show details</a>)</h3>';
                    if (count($results['SCRIPT']))
                    {
                        echo '<table class="ui selectable celled table small">';
                        echo '<thead><tr><th>JavaScripts Link or codes</th></thead>';
                        foreach ($results['SCRIPT'] as $link)
                        {
                            echo '<tr>';
                            echo '<td>'.$link.'</td>';
                            echo '</tr>';
                        }
                        echo '</table>';
                    }
                    else echo '<p>No iframes detected.</p>';
                }
                else {
                    /**
                     * Show detailed
                     */
                    $post_ids = array();
                    $post_titles = array();
                    if (count($params['results']['posts']['WORDS']))
                    {
                        foreach ($params['results']['posts']['WORDS'] as $post_id => $post_arr)
                        {
                            $post_ids[ $post_id ] = $post_id;
                        }
                    }
                    if (count($params['results']['posts']['A']))
                    {
                        foreach ($params['results']['posts']['A'] as $post_id => $post_arr)
                        {
                            $post_ids[ $post_id ] = $post_id;
                        }
                    }
                    if (count($params['results']['posts']['IFRAME']))
                    {
                        foreach ($params['results']['posts']['IFRAME'] as $post_id => $post_arr)
                        {
                            $post_ids[ $post_id ] = $post_id;
                        }
                    }
                    if (count($params['results']['posts']['SCRIPT']))
                    {
                        foreach ($params['results']['posts']['SCRIPT'] as $post_id => $post_arr)
                        {
                            $post_ids[ $post_id ] = $post_id;
                        }
                    }
                    $post_titles = SEO_SG_Protection::GetPostTitles_by_IDs($post_ids);
                    
                    echo '<h3>Detailed by article (<a href="index.php?option=com_seoprotection&showdetailed=0">show simple</a>)</h3>'; 
                    if (count($params['results']['posts']['WORDS']))
                    {
                        foreach ($params['results']['posts']['WORDS'] as $post_id => $post_arr)
                        {
                            if (count($post_arr))
                            {
                                $edit_link = 'index.php?option=com_content&view=article&layout=edit&id='.$post_id;
                                echo '<table class="ui selectable celled table small">';
                                echo '<thead><tr><th><b>Bad words in article ID: '.$post_id.'</b> ('.$post_titles[$post_id]/*SEO_SG_Protection::GetPostTitle_by_ID($post_id)*/.') <a href="'.$edit_link.'" target="_blank" class="edit_post"><i class="write icon"></i> edit</a></th></tr></thead>';
                                foreach ($post_arr as $word)
                                {
                                    echo '<tr>';
                                    echo '<td>'.$word.'</td>';
                                    echo '</tr>';
                                }
                                echo '</table>';
                            }
                        }
                    }
                    if (count($params['results']['posts']['A']))
                    {
                        foreach ($params['results']['posts']['A'] as $post_id => $post_arr)
                        {
                            if (count($post_arr))
                            {
                                $edit_link = 'index.php?option=com_content&view=article&layout=edit&id='.$post_id;
                                echo '<table class="ui selectable celled table small">';
                                echo '<thead><tr><th class="ten wide"><b>Links in article ID: '.$post_id.'</b> ('.$post_titles[$post_id]/*SEO_SG_Protection::GetPostTitle_by_ID($post_id)*/.') <a href="'.$edit_link.'" target="_blank" class="edit_post"><i class="write icon"></i> edit</a></th><th class="six wide">Text in links</th></tr></thead>';
                                foreach ($post_arr as $link_data)
                                {
                                    foreach ($link_data as $link => $txt)
                                    {
                                        echo '<tr>';
                                        echo '<td>'.$link.'</td><td>'.$txt.'</td>';
                                        echo '</tr>';
                                    }
                                }
                                echo '</table>';
                            }
                        }
                    }
                    //else echo '<p>No strange links detected.</p>';
//print_r($params['results']['posts']['IFRAME']);
                    if (count($params['results']['posts']['IFRAME']))
                    {
                        foreach ($params['results']['posts']['IFRAME'] as $post_id => $post_arr)
                        {
                            if (count($post_arr))
                            {
                                $edit_link = 'index.php?option=com_content&view=article&layout=edit&id='.$post_id;
                                echo '<table class="ui selectable celled table small">';
                                echo '<thead><tr><th><b>Iframes in article ID: '.$post_id.'</b> ('.$post_titles[$post_id]/*SEO_SG_Protection::GetPostTitle_by_ID($post_id)*/.') <a href="'.$edit_link.'" target="_blank" class="edit_post"><i class="write icon"></i> edit</a></th></tr></thead>';
                                foreach ($post_arr as $link)
                                {
                                    echo '<tr>';
                                    echo '<td>'.$link.'</td>';
                                    echo '</tr>';
                                }
                                echo '</table>';
                            }
                        }
                    }
                    //else echo '<p>No strange links detected.</p>';
//print_r($params['results']['posts']['SCRIPT']);exit;
                    if (count($params['results']['posts']['SCRIPT']))
                    {
                        foreach ($params['results']['posts']['SCRIPT'] as $post_id => $post_arr)
                        {
                            if (count($post_arr))
                            {
                                $edit_link = 'index.php?option=com_content&view=article&layout=edit&id='.$post_id;
                                echo '<table class="ui selectable celled table small">';
                                echo '<thead><tr><th><b>JavaScript in article ID: '.$post_id.'</b> ('.$post_titles[$post_id]/*SEO_SG_Protection::GetPostTitle_by_ID($post_id)*/.') <a href="'.$edit_link.'" target="_blank" class="edit_post"><i class="write icon"></i> edit</a></th></tr></thead>';
                                foreach ($post_arr as $js_link => $js_code)
                                {
                                    if ($js_code == '') $js_code = $js_link;
                                    echo '<tr>';
                                    echo '<td>'.$js_code.'</td>';
                                    echo '</tr>';
                                }
                                echo '</table>';
                            }
                        }
                    }
                    //else echo '<p>No strange links detected.</p>';
                }
                
                
            }
            else echo '<p class="msg_alert">No results. Please click <b>Start Scanner</b> button.</p>';
			
			?>
				</div>

				</div>	
			<?php
        } 
		

    ?>
    

